/*
 * (C) Copyright 2011- ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

#ifndef mir_ecbuild_config_h
#define mir_ecbuild_config_h

/* ecbuild info */

#ifndef ECBUILD_VERSION_STR
#define ECBUILD_VERSION_STR "3.2.0"
#endif
#ifndef ECBUILD_VERSION
#define ECBUILD_VERSION "3.2.0"
#endif
#ifndef ECBUILD_MACROS_DIR
#define ECBUILD_MACROS_DIR  "/build/metview-lFngZF/metview-5.7.5/cmake"
#endif

/* config info */

#define MIR_OS_NAME          "Linux-4.4.0-173-generic"
#define MIR_OS_BITS          32
#define MIR_OS_BITS_STR      "32"
#define MIR_OS_STR           "linux.32"
#define MIR_OS_VERSION       "4.4.0-173-generic"
#define MIR_SYS_PROCESSOR    "armv7l"

#define MIR_BUILD_TIMESTAMP  "20200202232209"
#define MIR_BUILD_TYPE       "Release"

#define MIR_C_COMPILER_ID      "GNU"
#define MIR_C_COMPILER_VERSION "9.2.1"

#define MIR_CXX_COMPILER_ID      "GNU"
#define MIR_CXX_COMPILER_VERSION "9.2.1"

#define MIR_C_COMPILER       "/usr/bin/cc"
#define MIR_C_FLAGS          "-g -O2 -fdebug-prefix-map=/build/metview-lFngZF/metview-5.7.5=. -fstack-protector-strong -Wall -pedantic -fPIC -Wdate-time -D_FORTIFY_SOURCE=2 -pipe -fopenmp -O3 -DNDEBUG"

#define MIR_CXX_COMPILER     "/usr/bin/c++"
#define MIR_CXX_FLAGS        "-g -O2 -fdebug-prefix-map=/build/metview-lFngZF/metview-5.7.5=. -fstack-protector-strong -std=gnu++14 -Wdate-time -D_FORTIFY_SOURCE=2 -pipe -fopenmp -O3 -DNDEBUG"

/* Needed for finding per package config files */

#define MIR_INSTALL_DIR       "/usr"
#define MIR_INSTALL_BIN_DIR   "/usr/bin"
#define MIR_INSTALL_LIB_DIR   "/usr/lib"
#define MIR_INSTALL_DATA_DIR  "/usr/share/mir"

#define MIR_DEVELOPER_SRC_DIR "/build/metview-lFngZF/metview-5.7.5"
#define MIR_DEVELOPER_BIN_DIR "/build/metview-lFngZF/metview-5.7.5/debian/build"

#define EC_HAVE_FORTRAN

#ifdef EC_HAVE_FORTRAN

#define MIR_Fortran_COMPILER_ID      "GNU"
#define MIR_Fortran_COMPILER_VERSION "9.2.1"

#define MIR_Fortran_COMPILER "/usr/bin/gfortran"
#define MIR_Fortran_FLAGS    "-g -O2 -fdebug-prefix-map=/build/metview-lFngZF/metview-5.7.5=. -fstack-protector-strong -I /usr/lib/arm-linux-gnueabihf/fortran/arm-linux-gnueabihf-gfortran-9 -fopenmp -O3 -DNDEBUG -funroll-all-loops -finline-functions"

#endif

#endif /* mir_ecbuild_config_h */
